use strict;
#------------------------------------------------------------------------------
# Amazonˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_amazon;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags = shift;
	$tags->{amazon} = {data => \&amazon_search};
	$tags->{asin}   = {data => \&amazon_asin};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# Amazonˡ(Amazon search)
#------------------------------------------------------------------------------
sub amazon_search {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $keyword = shift(@$ary);
	my $name    = $keyword;
	# ʸѴ
	my $ROBJ = $parser_obj->{ROBJ};
	my $system_coding = $ROBJ->{System_coding};
	if ($system_coding ne 'UTF-8') {
		my $jcode = $parser_obj->{jcode} ||= $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$keyword, $system_coding, 'UTF-8');
	}
	# URI󥳡
	$parser_obj->uri_encode($keyword);
	my $nihongo = "%E6%97%A5%E6%9C%AC%E8%AA%9E";	# 'ܸ' by UTF-8

	# ID &tag=user-id
	my $asid = $parser_obj->{asid};
	$asid =~ s/[^\w\-\.]//g;	# ʸ
	if ($asid ne '') { $asid="&tag=$asid"; }

	# ̾
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if (substr($name, 0, 5) eq 'title') { $name=substr($name, 6); }
	return "<a href=\"http://www.amazon.co.jp/exec/obidos/external-search?mode=blended$asid&encoding-string-jp=$nihongo&keyword=$keyword\"$tag->{class}$tag->{title}>$name</a>";
}

#------------------------------------------------------------------------------
# asin/isbnˡ(amazon)
#------------------------------------------------------------------------------
sub amazon_asin {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	# ID &tag=user-id
	my $asid = $parser_obj->{asid};
	$asid =~ s/[^\w\-\.]//g;	# ʸ
	if ($asid ne '') { $asid .= '/ref=nosim'; }

	# ASIN/ISBN
	my $asin = shift(@$ary);
	$asin =~ s/[^\w\-\.]//g;	# ʸ

	# ⡼ɡ
	if ($ary->[0] eq 'img' || $ary->[0] eq 'image' || $ary->[0] eq 'detail') {
		shift(@$ary);
		return &amazon_asin_image($parser_obj, $tag, $cmd, $ary, $asin, $asid);
	}

	# ̾
	$cmd =~ tr/a-z/A-Z/;
	my $name  = "$cmd:$asin";
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if (substr($name, 0, 5) eq 'title') { $name=substr($name, 6); }

	return "<module name=\"popup-image\" href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\" image_url=\"images-jp.amazon.com/images/P/$asin.09.MZZZZZZZ.jpg\"$tag->{class}>$name</a>";
	# return "<a href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\"$tag->{class}$tag->{title}>$name</a>";
}

#------------------------------------------------------------------------------
# asin/isbn - imageˡ(amazon)
#------------------------------------------------------------------------------
sub amazon_asin_image {
	my ($parser_obj, $tag, $cmd, $ary, $asin, $asid) = @_;

	# ǧ
	my $size = '.09.MZZZZZZZ.jpg';	# midium
	if ($ary->[0] eq 'large') {
		shift(@$ary);
		$size = '.09.LZZZZZZZ.jpg';
	} elsif ($ary->[0] eq 'small') {
		shift(@$ary);
		$size = '.09.THUMBZZZ.jpg';
	}
	my $size_tag;
	if    ($ary->[0] =~ /^w(\d+%?)$/) { $size_tag=" width=\"$1\"";  shift(@$ary); }
	elsif ($ary->[0] =~ /^h(\d+%?)$/) { $size_tag=" height=\"$1\""; shift(@$ary); }

	# target
	my $target = $parser_obj->{image_target};
	if (substr($ary->[0], 0, 6) eq 'target') { $target = substr(shift(@$ary), 7); }
	$target =~ s/\W//g;
	if ($target ne '') { $target=" target=\"$target\""; }

	# ȥ
	$cmd =~ tr/a-z/A-Z/;
	my $name  = "$cmd:$asin";
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if (substr($name, 0, 5) eq 'title') { $name=substr($name, 6); }
	$name =~ s/"/&quot;/g;

	return "<a href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\"$tag->{class}$tag->{title}$target><img src=\"http://images-jp.amazon.com/images/P/$asin$size\" alt=\"$name\" class=\"asin\"$size_tag></a>";
}


1;
